﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Mount : MonoBehaviour {
	
	public float max_hitpoints = 100f;
	public float hitpoints = 100f;
	public float taking_damage = 0.0f;
	public GameObject marker = null;
	
	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
		
	}
	
	public float GetHitpoints() {
		return hitpoints;
	}
	
	public float GetMaxHitpoints() {
		return max_hitpoints;
	}
	
	float CheckDamage() {
		if(hitpoints <= 0) {
			// destroy all children...
			var children = new List<GameObject>();
			foreach (Transform child in transform) children.Add(child.gameObject);
			children.ForEach(child => Destroy(child));
			if(marker != null) {
				GameObject go = Instantiate(marker) as GameObject;
				go.transform.parent = transform;
				go.transform.position = transform.position;
				go.transform.rotation = transform.rotation;
			}
			
			hitpoints = 0;
			Destroy(this); // TODO: Remove this when full repair is implemented...
		}	
		return hitpoints;
	}
	
	public float ApplyAttack(float damage) { // TODO: Add attack type
		if(hitpoints <= 0) { return 0; }
		taking_damage = Time.timeSinceLevelLoad + (damage / 2);
		hitpoints = hitpoints - damage;
		//Debug.DrawRay(transform.position, Vector3.forward, Color.red, 0.5f);
		CheckDamage();
		return damage;
	}
	
	public void OnDrawGizmos() {
		if(Time.timeSinceLevelLoad < taking_damage) {
			Gizmos.color = Color.red;
			Gizmos.DrawWireCube(transform.position, new Vector3(1.1f, 1.1f, 1.1f));
		}
	}
}
