﻿using UnityEngine;
using System.Collections;

public class Zeppelin : MonoBehaviour {
	
	float ship_rotation;
	float ship_drift;
	
	public float current_hitpoints;
	float max_hitpoints;
	
	// Use this for initialization
	void Start () {
	
	}
	
	void Awake() {
		DontDestroyOnLoad(transform.gameObject);
	}
	
	// Update is called once per frame
	void Update () {
		Flying();
		if(CheckDamage() <= 0) {
			// Game Over
			GameState.ChangeState(GameState.GSType.GameOver);
			//TODO: Blow up zeppelin...
			Destroy(this);
		}		
	}
	
	float CheckDamage() {
		// check hitpoints of all mounts...
		// TODO: use the engines as the final hitpoint sink, after the rest are gone...
		var mount_list = transform.GetComponentsInChildren<Mount>();
		float total_hitpoints = 0f;
		max_hitpoints = 0f;
		foreach(Mount m in mount_list) {
			total_hitpoints += m.GetHitpoints();
			max_hitpoints += m.GetMaxHitpoints();
		}
		current_hitpoints = total_hitpoints;
		return current_hitpoints;
	}
	
	void Flying() {
		var horz = Input.GetAxis("Horizontal");
		var vert = Input.GetAxis("Vertical");
		
		if(horz != 0f) {
			// Rotate ship
			ship_rotation += (horz * 0.01f);
			ship_rotation = Mathf.Clamp(ship_rotation, -0.5f, 0.5f);
			// Drift a bit
		} else {
			ship_rotation = (ship_rotation > 0.01f) ? (ship_rotation - 0.005f) : ((ship_rotation < -0.005f) ? (ship_rotation + 0.005f)  : 0);
		}
		
		if(horz != 0f) {
			ship_drift += 0.05f * ship_rotation;
			ship_drift = Mathf.Clamp(ship_drift, -5f, 5f);
		} else {
			if(ship_drift != 0) {
				float decay_intensity = Mathf.Lerp(0.95f, 0.99999f, Mathf.Abs(ship_drift * 0.2f));
				ship_drift *= decay_intensity;
				ship_drift = ((ship_drift > 0.001f) || (ship_drift < -0.001f)) ? ship_drift : 0f;
			}
		}
		
		Vector3 pos = transform.position;
		pos.x = 0f + ship_drift;
		transform.position = pos;
		
		float rot_delta = (ship_rotation) * 40f;
		rot_delta = Mathf.Lerp(-20f, 20f, ship_rotation + 0.5f);
		
		Quaternion rot = gameObject.transform.localRotation;
		float y = rot.eulerAngles.y;
		float delta = rot_delta;//ship_rotation;
		Quaternion delta_rot = Quaternion.Euler(0, (-90f-y) + delta, 0);
		rot = rot * delta_rot;
		gameObject.transform.localRotation = rot;	
	}
	
	public void Repair() {
		// TODO	
	}
}
